﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using FarPoint.Win.Spread;

namespace GetCurrentFilter
{
    public partial class Form1 : Form
    {
        string[] filterby;
        DataTable dt;
        FilterCondition fc1, fc2;
        bool multival, customfil;
        bool and;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FarPoint.Win.Spread.IRowFilter rf = fpSpread1.ActiveSheet.RowFilter;
            foreach (FilterColumnDefinition fcd in rf.ColumnDefinitions)
            {

                FilterItemCollection filters = fcd.Filters;
                IFilterItem iFilterItem = null;
                string filterString = fpSpread1.Sheets[0].RowFilter.GetColumnFilterBy(0);
                for (int i = 0, count = filters.Count; i < count; i++)
                {
                    if (filters[i].DisplayName == filterString)
                    {
                        iFilterItem = filters[i];
                        break;
                    }
                }
                if (iFilterItem is FarPoint.Win.Spread.MultiValuesFilterItem)
                {
                    multival = true;
                    customfil = false;
                    MultiValuesFilterItem mvFilterItem = iFilterItem as MultiValuesFilterItem;
                    if (mvFilterItem != null)
                    {
                        filterby = new string[mvFilterItem.FilterItems.Count];
                        int i = 0;
                        foreach (FarPoint.Win.Spread.FilterItemValue fi in mvFilterItem.FilterItems)
                        {
                            filterby[i] = fi.Value.ToString();
                            i++;
                        }

                    }
                }
                else if (iFilterItem is FarPoint.Win.Spread.CustomFilterItem)
                {
                    customfil = true;
                    multival = false;
                    CustomFilterItem cfFilterItem = iFilterItem as CustomFilterItem;
                    filterby = new string[3];
                    if (cfFilterItem != null)
                    {
                        fc1 = cfFilterItem.FirstCondition;
                        fc2 = cfFilterItem.SecondCondition;
                        and = cfFilterItem.And;
                    }
                }
            }
            MessageBox.Show("Filter state saved");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            dt = new DataTable();
            dt.Columns.AddRange(new DataColumn[] {new DataColumn("FirstName"),new DataColumn("LastName")});
	        dt.Rows.Add(new object[] {"Alice","Abbot"});
	        dt.Rows.Add(new object[] {"Alice","Anderson"});
	        dt.Rows.Add(new object[] {"Bill","Abbot"});
	        dt.Rows.Add(new object[] {"Bob","Bell"});
	        dt.Rows.Add(new object[] {"Bob","Hope"});
	        dt.Rows.Add(new object[] {"Jim","Bell"});
	        dt.Rows.Add(new object[] {"Cindy","Cooper"});
	        dt.Rows.Add(new object[] {"Nancy","Cooper"});
	        dt.Rows.Add(new object[] {"Cindy","Bell"});
	        fpSpread1.DataSource = dt;
	        fpSpread1.ActiveSheet.SetColumnAllowFilter(0, true);
            fpSpread1.ActiveSheet.AutoFilterMode = FarPoint.Win.Spread.AutoFilterMode.EnhancedContextMenu;
            fpSpread2.DataSource = dt;
            fpSpread2.ActiveSheet.AutoFilterMode = AutoFilterMode.EnhancedContextMenu;
        }
        private void button2_Click(object sender, EventArgs e)
        {
            fpSpread2.ActiveSheet.ClearRowFilter();
            fpSpread2.ActiveSheet.SetColumnAllowFilter(0, true);
            if (multival)
            {
                FilterItemValueCollection fc = new FilterItemValueCollection();
                for (int r = 0; r < filterby.Length; r++)
                {
                    fc.Add(new FarPoint.Win.Spread.FilterItemValue(filterby[r]));
                }
                MultiValuesFilterItem filter = new MultiValuesFilterItem(fc);
                filter.SheetView = fpSpread2.ActiveSheet;
                fpSpread2.ActiveSheet.RowFilter.ColumnDefinitions[0].Filters.Add(filter);
                fpSpread2.ActiveSheet.AutoFilterColumn(0, filter.DisplayName, 0);
                MessageBox.Show("Saved filter state applied to second spread");
            }
            else if (customfil)
            {
                CustomFilterItem cff = new CustomFilterItem(fc1, fc2, and);
                cff.SheetView = fpSpread2.ActiveSheet;
                fpSpread2.ActiveSheet.RowFilter.ColumnDefinitions[0].Filters.Add(cff);
                fpSpread2.ActiveSheet.AutoFilterColumn(0, cff.DisplayName, 0);
                MessageBox.Show("Saved filter state applied to second spread");
            }
        }
    }
}
